﻿using System;
using System.Globalization;
using System.Linq;
using System.Windows.Browser;
using System.Windows.Controls;
using System.Windows.Media;

namespace SlGridDemo1 {
	public partial class Page : UserControl {
		public Page() {
			InitializeComponent();
		}

		private object ConvertAge(object value, Type targetType, object parameter, CultureInfo culture) {
			int age;
			bool success = int.TryParse(value.ToString(), out age);
			if (!success) {
				return value;
			}

			Grid grid = new Grid();

			if (age > 30) {
				grid.Children.Add(new TextBlock { Text = string.Format("{0}, (over 30)", age) });
				grid.Background = new SolidColorBrush(Colors.Red);
			}
			else {
				grid.Children.Add(new TextBlock { Text = age.ToString() });
				grid.Background = new SolidColorBrush(Colors.Green);
			}
			return grid;
		}

		private object ConvertName(object value, Type targetType, object parameter, CultureInfo culture) {
			Employee employee = value as Employee;
			if (employee == null) {
				return value;
			}

			if (employee.FirstName.Contains('a')) {
				Button btn = new Button();
				btn.Content = employee.FirstName;
				btn.Click += ((sender, e) => {
					HtmlPage.Window.Alert(
						string.Format("There is a button here because \"{0}\" contains an \"a\".", 
						employee.FirstName));
				});

				return btn;
			}
			return new TextBlock {Text = employee.FirstName};
		}

	}
}
