﻿using System;
using System.Globalization;
using System.Windows.Data;

namespace SlGridDemo1 {
	public class UniversalConverter : IValueConverter {

		public object Convert(object value, Type targetType, object parameter, CultureInfo culture) {
			return this.OnConverting(value, targetType, parameter, culture);
		}

		public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture) {
			return this.OnConvertingBack(value, targetType, parameter, culture);
		}

		protected object OnConverting(object value, Type targetType, object parameter, CultureInfo culture) {
			UniversalConverterHandler handler = this.Converting;
			if (handler != null) {
				return handler(value, targetType, parameter, culture);
			}
			return value;
		}

		protected object OnConvertingBack(object value, Type targetType, object parameter, CultureInfo culture) {
			UniversalConverterHandler handler = this.ConvertingBack;
			if (handler != null) {
				return handler(value, targetType, parameter, culture);
			}
			return value;
		}

		public event UniversalConverterHandler Converting;

		public event UniversalConverterHandler ConvertingBack;

	}

	public delegate object UniversalConverterHandler(object value, Type targetType, object parameter, CultureInfo culture);

}
